=== debian/changelog ===
plplot (5.15.0+dfsg2-9build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:48:10 +0000
