=== debian/control ===
Source: plplot
Section: math
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>,
           Rafael Laboissière <rafael@debian.org>
Standards-Version: 4.6.2
Build-Depends: camlidl,
               chrpath,
               cmake (>= 2.6.3),
               debhelper-compat (= 13),
               default-jdk,
               dh-ada-library (>= 9.1),
               dh-sequence-ada-library,
               dh-fortran-mod,
               dh-ocaml,
               dh-octave,
               dh-python,
               fonts-freefont-ttf,
               gfortran,
               gnat (>= 13.1),
               iwidgets4 (>= 4.1.0-2),
               javahelper,
               libgl1-mesa-dri,
               libhpdf-dev,
               libltdl-dev,
               liblua5.1-0-dev,
               libpango1.0-dev,
               libqhull-dev (>= 2003.1-8),
               libqt5svg5-dev,
               libshp-dev,
               libwxgtk3.2-dev,
               libx11-dev,
               libxext-dev,
               libxml-dom-perl,
               libxml-parser-perl,
               lua5.1,
               m4,
               ocaml-findlib,
               ocaml-nox,
               pkgconf,
               pyqt5-dev,
               python3-dev,
               python3-numpy (>= 1:1.4.1-4~),
               python3-pyqtbuild,
               qtbase5-dev,
               qtchooser,
               sip-tools,
               swig,
               tcl-dev,
               tcl-itcl4-dev,
               tk-dev,
               tk-itk4-dev,
               xauth,
               xvfb
Build-Depends-Indep: dblatex,
                     docbook-xml,
                     docbook-xsl,
                     docbook2x,
                     fop,
                     ghostscript,
                     lmodern,
                     texlive-xetex,
                     xmlto
Homepage: http://www.plplot.org
Vcs-Browser: https://salsa.debian.org/science-team/plplot
Vcs-Git: https://salsa.debian.org/science-team/plplot.git
Rules-Requires-Root: no

Package: libplplot-dev
Architecture: any
Section: libdevel
Recommends: cmake,
            libplplot-lua,
            libplplot-ocaml,
            pkgconf
Suggests: plplot-doc, plplot-examples
Depends: libfreetype-dev,
         libltdl-dev,
         libcsironn0 (= ${binary:Version}),
         libcsirocsa0 (= ${binary:Version}),
         libplplot17 (= ${binary:Version}),
         libplplotcxx15 (= ${binary:Version}),
         libplplotfortran0 (= ${binary:Version}),
         libplplotqt2 (= ${binary:Version}),
         libplplotwxwidgets1 (= ${binary:Version}),
         libqhull-dev,
         libqsastime-dev,
         libshp-dev,
         ${misc:Depends},
         ${fortran:Depends}
Breaks: libplplot-fortran9 (<< 5.9.8-1)
Description: Scientific plotting library (development files)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains all that is needed for doing development in C,
 C++ and Fortran with PLplot. For development in Tcl/Tk, Python and
 Java, install the plplot-tcl-dev, python3-plplot and libplplot-java
 packages, respectively. This package also includes the OCaml and Lua
 examples. To use one of these languages you will also need to install
 the libplplot-xxx package for that language.

Package: libplplot-data
Architecture: all
Section: libs
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: libplplot17 (<< 5.15.0+dfsg-8)
Replaces: libplplot17 (<< 5.15.0+dfsg-8)
Description: Scientific plotting library (data files)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the architecture-independent data files used by
 the PLplot C library.

Package: libplplot17
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libplplot-data (= ${source:Version})
Suggests: plplot-driver-cairo,
          plplot-driver-gd,
          plplot-driver-qt,
          plplot-driver-wxwidgets,
          plplot-driver-xwin,
          plplot-tcl
Replaces: plplot-bin (<< 5.9.6-1)
Breaks: plplot-bin (<< 5.9.6-1)
Description: Scientific plotting library
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the PLplot library for C.

Package: libplplotcxx15
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Scientific plotting library (C++ binding)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the C++ binding for PLplot.

Package: libplplotfortran0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Scientific plotting library (fortran bindings)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the Fortran 95 bindings for PLplot. Note: the Fortran
 77 bindings have been deprecated upstream for some time and have now been
 dropped from the Debian packages.

Package: libplplot-java
Architecture: any
Section: java
Conflicts: libplplot9-java
Replaces: libplplot9-java
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${java:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Scientific plotting library (Java bindings)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package contains the Java bindings for PLplot.

Package: libcsironn0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Replaces: libcsiro0 (<< 5.12.0-1)
Breaks: libcsiro0 (<< 5.12.0-1)
Description: Scientific plotting library (CSIRO nn library)
 This package contains the Natural Neighbours interpolation library
 developed by Pavel Sakov, from the CSIRO Marine Research.
 .
 The source code for these libraries are part of the plplot source
 package.

Package: libcsirocsa0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Replaces: libcsiro0 (<< 5.12.0-1)
Breaks: libcsiro0 (<< 5.12.0-1)
Description: Scientific plotting library (CSIRO csa library)
 This package contains the bivariate Cubic Spline Approximation library
 developed by Pavel Sakov, from the CSIRO Marine Research.
 .
 The source code for these libraries are part of the plplot source
 package.

Package: libqsastime0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Time format conversion library
 The qsastime library is a simple library for handling time format
 conversion. It overcomes the limitations of the POSIX time handling
 routines by allow high precision time variables over a large range
 of ranges of dates and by correctly handling leap seconds. It was
 designed with the needs of scientific data plotting in mind. This
 package provides the runtime library.
 .
 The source code for this library is part of the plplot source
 package.

Package: libqsastime-dev
Architecture: any
Section: libdevel
Breaks: libplplot-dev (<< 5.9.8-1)
Multi-Arch: same
Depends: libqsastime0 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Time format conversion library (development files)
 The qsastime library is a simple library for handling time format
 conversion. It overcomes the limitations of the POSIX time handling
 routines by allow high precision time variables over a large range
 of ranges of dates and by correctly handling leap seconds. It was
 designed with the needs of scientific data plotting in mind. This
 package provides the necessary files to do development with
 libqsastime.
 .
 The source code for this library is part of the plplot source
 package.

Package: plplot-driver-xwin
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: same
Conflicts: plplot12-driver-xwin
Replaces: plplot12-driver-xwin
Description: Scientific plotting library (X11 driver)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
 This package provides the X11 driver module for PLplot.

Package: plplot-driver-wxwidgets
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: plplot12-driver-wxwidgets
Replaces: plplot12-driver-wxwidgets
Description: Scientific plotting library (wxWidgets driver)
 PLplot is relatively small, portable, freely distributable, and is rich
 enough to satisfy most users.  It has a wide range of plot types including
 line (linear, log), contour, 3D, fill, and almost 1000 characters
 (including Greek and mathematical) in its extended font set.  The package
 is designed to make it easy to quickly get graphical output; only a
 handful of function calls is typically required.  For more advanced use,
 virtually all aspects of plotting are configurable.
 .
