=== debian/tests/control ===
Tests: plplot-test
Depends: @, @builddeps@
Restrictions: allow-stderr

Tests: ada-project-shared
Depends: gprbuild, libplplotada-dev
